Package org.spongepowered.asm.mixin.transformer.struct

## Enum Initialiser.InjectionMode

- java.lang.Object
- - java.lang.Enum<Initialiser.InjectionMode>
  - - org.spongepowered.asm.mixin.transformer.struct.Initialiser.InjectionMode

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<Initialiser.InjectionMode>`
  Enclosing class:
    Initialiser

      public static enum Initialiser.InjectionMode
      extends java.lang.Enum<Initialiser.InjectionMode>

  Strategy for injecting initialiser insns

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `DEFAULT` | Default mode, attempts to place initialisers after all other competing initialisers in the target ctor
    `SAFE` | Safe mode, only injects initialiser directly after the super-ctor invocation

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Initialiser.InjectionMode` | `ofEnvironment​(MixinEnvironment env)` | Get the injection mode based on the the environment
    `static Initialiser.InjectionMode` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static Initialiser.InjectionMode[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### DEFAULT

          public static final Initialiser.InjectionMode DEFAULT

      Default mode, attempts to place initialisers after all other competing initialisers in the target ctor

    - #### SAFE

          public static final Initialiser.InjectionMode SAFE

      Safe mode, only injects initialiser directly after the super-ctor invocation

  - ### Method Detail

    - #### values

          public static Initialiser.InjectionMode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Initialiser.InjectionMode c : Initialiser.InjectionMode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Initialiser.InjectionMode valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### ofEnvironment

          public static Initialiser.InjectionMode ofEnvironment​(MixinEnvironment env)

      Get the injection mode based on the the environment
      Parameters:
        `env` - Environment to query for the injection mode option